/**
 * A simple example to illustrate software validation.
 * 
 * <p>
 * We wish to implement a password setting policy scheme,
 * where a password is considered "OK" if all of the following conditions 
 * are met:
 * <ol>
 * <li>The length is between 10 and 20 characters.</li>
 * <li>It contains at least one upper-case character.</li>
 * <li>It contains at least one lower-case character.</li>
 * <li>It contains at least one decimal digit.</li>
 * <li>It may (but need not) contain at most one punctuation symbol, i.e., one of
 * the following
 * <code>. : ? ! , ;</code>.</li>
 * <li>It does not contain any character that does not fit 
 * in one of the above categories.</li>
 * </ol>
 * 
 * @author Eduardo Marques
 */
package qses.pwcheck;