package qses.apache.commons;

import static org.junit.Assert.assertTrue;

import java.io.IOException;

import java.net.URISyntaxException;

import org.junit.BeforeClass;
import org.junit.Test;

import com.github.nradov.abnffuzzer.Fuzzer;


public class InetAddressValidatorTestUsingABNFFuzzer {

  static final InetAddressValidator VALIDATOR = InetAddressValidator.getInstance();
  static final int TEST_CASES = 1000;
  static Fuzzer fuzzer;

  @BeforeClass
  public static void setup() throws IOException {
    fuzzer = new Fuzzer(InetAddressValidatorTestUsingABNFFuzzer.class.getResourceAsStream("/rfc3986.txt"));
  }

  @Test
  public void testIPV4Validation() throws IOException, URISyntaxException {
    for (int i = 0; i < TEST_CASES; i++) {
      String ipV4Address = fuzzer.generateAscii("IPv4address");
      assertTrue(VALIDATOR.isValidInet4Address(ipV4Address));
    }
  }
  
  @Test
  public void testIPV6Validation() throws IOException, URISyntaxException {
    for (int i = 0; i < TEST_CASES; i++) {
      String ipV6Address = fuzzer.generateAscii("IPv6address");
      assertTrue(VALIDATOR.isValidInet6Address(ipV6Address));
    }
  }


}
