package qses.arrays;

import static org.junit.Assert.assertEquals;
import static qses.arrays.ArrayOperations.findLast;

import org.junit.Test;

public class ArrayOperationsFindLastTest {

  @Test(expected=NullPointerException.class)
  public void testFindLastWhenArrayIsNull() {
    int x[] = null;
    int y = 0;
    findLast(x, y);
  }
  
  
  @Test
  public void testFindLastWhenNotInArray() {
    int x[] = {1 ,2 }; 
    int y = 3;
    int index = findLast(x, y);
    assertEquals("not found",  -1, index);
  }

  @Test
  public void testFindLastWhenInArray() {
    int x[] = {0, 1 , 22, 3, 4, 5 }; 
    int y = 22;
    int index = findLast(x, y);
    assertEquals("not found",  2, index);
  }
  
  @Test
  public void testFindLastWhenInPositionZero() {
    int x[] = {22, 0, 1 , 2 }; 
    int y = 22;
    int index = findLast(x, y);
    assertEquals("not found",  0, index);
  }
}
