package qses.arrays;

import static org.junit.Assert.assertEquals;
import static qses.arrays.ArrayOperations.numZero;

import org.junit.Test;

public class ArrayOperationsNumZeroTest {

  @Test (expected = NullPointerException.class)
  public void testWithNullArgument() {
    int[] x = null;
    numZero(x);
  }
  
  @Test
  public void testWithEmptyArray() {
    int x[] = {}; 
    int n = numZero(x);
    assertEquals("count of zeros",  0, n);
  }

  @Test 
  public void testWithArrayWithoutZeros() {
    int[] x = { 1, 2 };
    int n = numZero(x);
    assertEquals("count of zeros", 0, n);
  }

  @Test // Should fail!!
  public void testWithArrayFilledWithZeros() {
    int[] x = {  0, 0 };
    int n = numZero(x);
    assertEquals("count of zeros", 2, n);
  }
  
  @Test 
  public void testWithArrayContainingOneZero() {
    int[] x = {  1, 1, 0 };
    int n = numZero(x);
    assertEquals("count of zeros", 1, n);
  }
}
