package qses.pwcheck;

import static org.junit.Assert.*;

import org.junit.Test;

//import qses.pwcheck.BuggyChecker;
import qses.pwcheck.PasswordChecker;

public class PasswordCheckerTest {

  static PasswordChecker CHECKER = CorrectChecker.INSTANCE;
  
  //static final PasswordChecker CHECKER = BuggyChecker.INSTANCE;

  
  @Test
  public void test1Verbose() {
    // Define inputs
    String input = "Abc1234567890";
    // Exercise SUT (Subject Under Test)
    boolean actual = CHECKER.isPasswordOK(input);
    // Check expected results
    assertEquals(true, actual);
  }
  
  @Test
  public void testValidPass() {
    assertTrue(CHECKER.isPasswordOK("Abc1234567890"));
  }
  
  @Test
  public void testValidPassWithLength10() {
    assertTrue(CHECKER.isPasswordOK("Ab12345678"));
  }
  
  @Test
  public void testNullPassword() {
    assertFalse(CHECKER.isPasswordOK(null));
  }
  
  @Test
  public void testValidPassWithLength20() {
    assertTrue(CHECKER.isPasswordOK("Ab12345678Ab12345678"));
  }
  
  @Test
  public void testSmallPassword() {
    assertFalse(CHECKER.isPasswordOK("Ab1234567"));
  }
  
  @Test
  public void testLongPassword() {
    assertFalse(CHECKER.isPasswordOK("Ab1234567890123456789"));
  }
  
  @Test
  public void testNoUppercase() {
    assertFalse(CHECKER.isPasswordOK("abc1234567890"));
  }
  
  @Test
  public void testNoLowerCase() {
    assertFalse(CHECKER.isPasswordOK("ABC1234567890"));
  }
  
  @Test
  public void testNoDigits() {
    assertFalse(CHECKER.isPasswordOK("ABCdefghijk"));
  }
  
  @Test
  public void testValidPassWithPunct() {
    assertTrue(CHECKER.isPasswordOK("?Abc1234567890"));
  }
  
  @Test
  public void testValidPassWithPunct2() {
    assertTrue(CHECKER.isPasswordOK(",Abc1234567890"));
  }
  
  @Test
  public void testInvalidPassWithPunct() {
    assertFalse(CHECKER.isPasswordOK("!Abc123456?7890"));
  }
  
  @Test
  public void testWithInvalidChar() {
    assertFalse(CHECKER.isPasswordOK("!Abc#1234567890"));
  }
  
  @Test
  public void testWithInvalidChar2() {
    assertFalse(CHECKER.isPasswordOK("!Abc12#34567890"));
  }
  
}
